; file      : mdisplay.asm
; author    : A. Price
; date      : 18-JAN-2001
; purpose   : Writing Data to the LCD Display
; used by   : Library routine
;
; Copyright (C) Lascar Electronics Ltd 2001
;
; This library is free software; you can redistribute it and/or
; modify it under the terms of the GNU Lesser General Public
; License as published by the Free Software Foundation; either
; version 2.1 of the License, or (at your option) any later version.
;
; This library is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; Lesser General Public License for more details.

; You should have received a copy of the GNU Lesser General Public
; License along with this library; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA
;
;***************************************************************************
;
__config       0x3FB9          ; --11 1111 1011 1001

; --11 ---- --11 ---- Code Protection OFF
; ---- 1--- ---- ---- Debug OFF
; ---- -x-- ---- ---- Unimplemented
; ---- --1- ---- ---- Flash Write Enable
; ---- ---1 ---- ---- EEPROM protect OFF
; ---- ---- 1--- ---- LVP enabled
; ---- ---- -0-- ---- BOR disabled
; ---- ---- ---- 1--- PWRTE disabled
; ---- ---- ---- -0-- WDT disabled
; ---- ---- ---- --01 XT Oscillator
;
;***************************************************************************
;***SPECIAL FUNCTION REGISTER EQUATES...
;

#include sfr_1-0.h

;***************************************************************************
;***USER REGISTER DEFINITIONS...

#include defn_1-0.h

;***************************************************************************
; Program start...


	ORG     00H	    	;Memory start address
	NOP
	GOTO    INIT    	;Program starts at INIT (bottom of page)



;****************************************************************************
;								    O	AAAAAAA
;								       FG  H  IB
;							               F G H I B
;Look-up table selects digit display segments from		    R  F  GHI  B
;their ASCII values.							JJJ KKK
;16 bits are required to define each starburst digit		    R  E  LMN  C
;so that each digit requires 2 lines of look-up table		       E L M N C	
;lookup table A deals with segments BAFCDEJO on COM1		       EL  M  NC	
;lookup table B deals with segments IHGNMLKR on COM2		    O	DDDDDDD
;
;*****IMPORTANT NOTE: 	IF THE LCD IS REVERSED FOR 12 OCLOCK VIEWING ANGLE
;			THEN SEGMENTS J AND K MUST BE INVERTED WITHIN THE LOOKUPS
;			IE. CHANGE 0 TO 1 OR 1 TO 0.
;							 
LUT_A   ADDWF   pcl,f        ;L2;Adds ASCII to program counter
;
;				     ASCII    SEGMENT   	
;				   dec	hex	hex     
        RETLW   b'00000000'     ;SP 32  20	00	
        RETLW   b'00000000'     ;   33  21	00	user defined
        RETLW   b'00000000'     ;   34  22	00	user defined	
        RETLW   b'00000000'     ;   35  23	00	user defined
        RETLW   b'00000000'     ;   36  24	00	user defined
        RETLW   b'00000000'     ;   37  25	00	user defined
        RETLW   b'11100010'     ;o  38  26	E2	degree 
        RETLW   b'00011110'     ;o  39  27	1E	lower case
        RETLW   b'01101100'     ;[  40  28	6C	
        RETLW   b'11011000'     ; ] 41  29	D8	
        RETLW   b'00000010'     ;*  42  2A	02	
        RETLW   b'00000010'     ;+  43  2B	02
        RETLW   b'01000010'     ;ohm45  2D	02
        RETLW   b'00000010'     ;-  44  2C	02	
        RETLW   b'00000001'     ;.  46  2E	01	
        RETLW   b'00000000'     ;/  47  2F	00	
        RETLW   b'11111100'     ;0  48  30	FC      
        RETLW   b'10010000'     ;1  49  31	90	
        RETLW   b'11001110'     ;2  50  32	CE	
        RETLW   b'11011000'     ;3  51  33	D8	
        RETLW   b'10110010'     ;4  52  34	B2      
        RETLW   b'01111010'     ;5  53  35	7A	
        RETLW   b'01111110'     ;6  54  36	7E	
        RETLW   b'11010000'     ;7  55  37	D0	
        RETLW   b'11111110'     ;8  56  38	FE	
        RETLW   b'11111010'     ;9  57  39	FA	
        RETLW   b'00011100'     ;u  58	3A	1C	
        RETLW   b'01111010'     ;$  59	3B	7A	
        RETLW   b'00000000'     ;<  60	3C	00	
        RETLW   b'01001010'     ;  61	3D	4A	
        RETLW   b'00000000'     ;>  62	3E	00	
        RETLW   b'11100001'     ;?  63	3F	E1	
        RETLW   b'00010110'     ;m  64  40	16	
        RETLW   b'11110110'     ;A  65  41	F6      
        RETLW   b'11011000'     ;B  66  42	D8	
        RETLW   b'01101100'     ;C  67  43	6C	
        RETLW   b'11011000'     ;D  68  44	D8	
        RETLW   b'01101110'     ;E  69  45	6E	
        RETLW   b'01100110'     ;F  70  46	66	
        RETLW   b'01111100'     ;G  71  47	7C	
        RETLW   b'10110110'     ;H  72  48	B6	
        RETLW   b'01001000'     ;I  73  49	48	
        RETLW   b'10011100'     ;J  74  4A	9C	
        RETLW   b'00100110'     ;K  75  4B	26	
        RETLW   b'00101100'     ;L  76  4C	2C	
        RETLW   b'10110100'     ;M  77  4D	B4	
        RETLW   b'10110100'     ;N  78  4E	B4	
        RETLW   b'11111100'     ;O  79  4F	FC	
        RETLW   b'11100110'     ;P  80  50	E6	
        RETLW   b'11111100'     ;Q  81  51	FC	
        RETLW   b'11100110'     ;R  82  52	E6	
        RETLW   b'01111010'     ;S  83  53	7A	
        RETLW   b'01000000'     ;T  84  54	40	
        RETLW   b'10111100'     ;U  85  55	BC	
        RETLW   b'00100100'     ;V  86  56	24	
        RETLW   b'10111100'     ;W  87  57	BC
        RETLW   b'00000000'     ;X  88	58	00	
        RETLW   b'00000000'     ;Y  89	59	00	
        RETLW   b'01001000'     ;Z  90  5A	48	
        RETLW   b'01101100'     ;[  91  5B	6C
        RETLW   b'00000000'     ;\  92	5C	00	
        RETLW   b'11011000'     ;]  93  5D	D8	
        RETLW   B'00000000'     ;v  94	5E	00	
        RETLW   b'00001000'     ;_  95  5F	08H	
	BSF	LUT_FLG		;LUT end identifier
	RETURN
;       
;lookup table B deals with segments IHGNMLJR on COM2
;
LUT_B    ADDWF   pcl,f        ;L3;Adds ASCII to pc
;
;				    ASCII     SEGMENT   
;				  value	hex	hex     
        RETLW   b'00000000'     ;SP 32	20	00	
        RETLW   b'00000000'     ;   33	21	00	 user defined
        RETLW   b'00000000'     ;   34  22	00	 user defined	
        RETLW   b'00000000'     ;   35  23	00	 user defined
        RETLW   b'00000000'     ;   36  24	00	 user defined
        RETLW   b'00000000'	;   37	25	00	 user defined
        RETLW   b'00000010'     ;o  38	26	02	 degree
        RETLW   b'00000010'     ;o  39  27	02	 lower case o	
        RETLW   b'00000000'     ;[  40	28	00	 
        RETLW   b'00000000'     ;]  41	29	00	
        RETLW   b'11111110'     ;*  42  2A	FE	
        RETLW   b'01001010'     ;+  43  2B	4A
        RETLW   b'10100010'	;ohm45	2D	A2		
        RETLW   b'00000010'     ;-  44  2C	02	
        RETLW   b'00000000'     ;.  46	2E	00	
        RETLW   b'10000100'     ;/  47  2F	84	
        RETLW   b'00000000'     ;0  48	30	00	
        RETLW   b'00000000'     ;1  49	31	00	
        RETLW   b'00000010'     ;2  50  32	02	
        RETLW   b'00000010'     ;3  51  33	02	
        RETLW   b'00000010'     ;4  52  34	02	
        RETLW   b'00000010'     ;5  53  35	02	
        RETLW   b'00000010'     ;6  54  36	02	
        RETLW   b'00000000'     ;7  55	37	00	
        RETLW   b'00000010'     ;8  56  38	02	
        RETLW   b'00000010'     ;9  57  39	02	
        RETLW   b'00000000'     ;u  58  3A	42	
        RETLW   b'01001010'     ;$  59	3B	4A	
        RETLW   b'10010000'     ;<  60  3C	90	
        RETLW   b'00100110'     ;  61	3D	26	
        RETLW   b'00100100'     ;>  62  3E	24	
        RETLW   b'00001010'     ;?  63	3F	0A	
        RETLW   b'00001010'     ;m  64  40	0A	
        RETLW   b'00000010'     ;A  65  41	02	
        RETLW   b'01001010'     ;B  66  42	4A	
        RETLW   b'00000000'     ;C  67	43	00	
        RETLW   b'01001000'     ;D  68  44	48	
        RETLW   b'00000000'     ;E  69  45	00	
        RETLW   b'00000000'     ;F  70  46	00	
        RETLW   b'00000010'     ;G  71  47	02	
        RETLW   b'00000010'     ;H  72  48	02	
        RETLW   b'01001000'     ;I  73  49	48	        
	RETLW   b'00000000'     ;J  74	5A	00
        RETLW   b'10010000'     ;K  75  5B	90	
        RETLW   b'00000000'     ;L  76	5C	00	
        RETLW   b'10100000'     ;M  77  5D	A0	
        RETLW   b'00110000'     ;N  78	5E	30	
        RETLW   b'00000000'     ;O  79	5F	00	
        RETLW   b'00000010'     ;P  80	60	02	
        RETLW   b'00010000'     ;Q  81  61	10	
        RETLW   b'00010010'     ;R  82  62	12	
        RETLW   b'00000010'     ;S  83  63	02	
        RETLW   b'01001000'     ;T  84  64	48	
        RETLW   b'0000000'      ;U  85	65	00	
        RETLW   b'10000100'     ;V  86  66	84	
        RETLW   b'00001000'     ;W  87  67	08	
        RETLW   b'10110100'     ;X  88  68	B4	
        RETLW   b'10101000'     ;Y  89  69	A8	
        RETLW   b'10000100'     ;Z  90  6A	84	
        RETLW   b'00000000'     ;[  91	6B	00	
        RETLW   b'00110000'     ;\  92  6C	30	
        RETLW   b'00000000'     ;]  93	6D	00
        RETLW   b'10100000'     ;v  94	6E	A0
        RETLW   b'00000000'     ;_  95	6F	00
	BSF	LUT_FLG		;LUT end identifier
	RETURN
	
;
;***CONVERT ASCII DIGITS TO DISPLAY SEGMENTS***...
;
ASL_B	CALL	LUT_B		;Fetch 'B' display segments
	GOTO	ASL2		;and implement
ASC_SEGS
	MOVF	DIGADR,w	;Address of DIG1n
	MOVWF	PTR1		;Load DIG pointer
	MOVLW	020H		;Address of SHIFT5
	MOVWF	PTR2		;Load SHIFT pointer
ASL1	MOVF	PTR1,w		;w=PTR1
	MOVWF	fsr		;fsr=PTR1=DIGnn address
	MOVF	indf,w	   	;get contents of DIGnn
	MOVWF	ASCII		;and hold in ASCII
	MOVLW	020H		;LUT offset
	SUBWF	ASCII,w		;ASCII-20H
	BTFSC	B_SEGS		;Is B flag set
	GOTO	ASL_B		;Yes? Then LUT numbers offset=+28H
	CALL	LUT_A		;Fetch 'A' segments
ASL2	MOVWF	TEMP1		;Hold segment data in TEMP1
	MOVF	PTR2,w		;Restore SHIFT address
	MOVWF	fsr		;fsr=PTR2=SHIFT address
	MOVF	TEMP1,w		;restore segment
	MOVWF	indf		;move data into SHIFTn
	INCF	PTR1,f	   	;point to next DIG register
	INCF	PTR2,f	   	;point to next SHIFT register	
	MOVLW	025H		;address of SHIFT1+1
	SUBWF	PTR2,w		;subtract from fsr
	BTFSS	zero		;Finished?
	GOTO	ASL1        	;No? Then loop
	BCF	B_SEGS		;Clear 'B' segments flag
	RETURN

;This subroutine should be called twice:- 
;To fetch the 'A' segments for COM1
;To fetch the 'B' segments for COM2
;
;The first 5 'B' DIGits have now been transferred to SHIFT 'B' registers.
;The main program should now call the ASSEMBLE routine to build a 43 bit COM2 string 
;to feed the LCD  via portb,4,5.  
;
;***CONVERT BCD NUMERALS TO DISPLAY SEGMENTS (direct)***...
;
TAB_B	CALL	LUT_B		;Fetch 'B' display segments
	GOTO	NUMS2		;and implement
;
;Direct access to the LUT tables...
NUM_SEGS
	MOVLW	026H		;Address of BCD1
	MOVWF	PTR1		;hold in pointer1
	MOVLW	024H		;Address of SHIFT1
	MOVWF	PTR2		;hold in pointer2
	MOVF	DPM,w		;Get digit position modifier
	SUBWF	PTR2,f		;modify SHIFT pointer
NUMS1	MOVF	PTR1,w		;w=BCD pointer
	MOVWF	fsr		;point to BCDn
	MOVF	indf,w		;get contents of BCDn
	MOVWF	TEMP3		;and hold in TEMP1
	MOVLW	010H		;No? Then LUT_A offset
	ADDWF	TEMP3,w		;add to value in BCD1
	BTFSC	B_SEGS		;Is 'B' flag set for LUT'B'?
	GOTO	TAB_B		;Yes?
	CALL	LUT_A		;Get 'A; display segments
NUMS2	MOVWF	TEMP4		;hold in TEMP2
	MOVF	PTR2,w		;Restore SHIFT address
	MOVWF	fsr		;file select register points to SHIFTn
	MOVF	TEMP4,w		;Restore value from BCDn
	MOVWF	indf		;put display segments into SHIFT
	INCF	PTR1,f	   	;point to next BCD register
	DECF	PTR2,f	   	;point to next SHIFT register	
	MOVLW	01FH		;address of SHIFT5+1
	SUBWF	PTR2,w		;subtract from fsr
	BTFSS	zero		;Finished?
	GOTO	NUMS1        	;No? Then loop
	BCF	B_SEGS		;Clear 'B' segments flag
	RETURN
;This subroutine should be called twice:- 
;To fetch the 'A' segments for COM1
;To fetch the 'B' segments for COM2
;
;The first 5 numerals have now been transferred to SHIFT 'B' registers.
;The main program should now call the ASSEMBLE routine to build a 43 bit COM2 string 
;to feed the LCD  via portb,4,5. 
;
;**************************************************************************
;
;***EP_1 DISPLAY DRIVER SUBROUTINES***
;
;Load Display Driver routine...
;
;LCD Driver accepts two data blocks A&B of 42 bits 
;corresponding to 42 segments, 5 digits. A 43rd bit 
;sets which block is Lo-COM1/Hi-COM2
;These data blocks are held in the SHIFT registers 1 to 5
;SHIFTX holds the 43rd COM bit.
;
;LOAD,DATA & CLOCK use Portb,2,4,5 respectively
;These ports are not available for user use.
;
;***ASSEMBLE 43BIT WORD LCD DRIVER routine***
;
ASSEMBLE                     	;       
        BSF     rb0             ;Bank 1
        BCF     rb1             ;selected
        MOVLW   b'00000000'     ;set up portb O/Ps
        MOVWF   trisb           ;write port tris reg
        BCF     rb0             ;Back to bank 0
       	BCF	DATA
	BCF	CLOCK
	BCF	LOAD
        BCF     carry           ;clear carry bit
        MOVLW   .43             ;Ready to shift 43 bits (2BH)
        MOVWF   BITS            ;use 'BITS' to hold 43 bits
ASMBL1  BCF     carry       	;Clear carry flag 
        RLF     SHIFTX,f        ;and carry is 1 or 0 
        RLF     SHIFT5,f        ;Shift register into
        RLF     SHIFT4,f        ;lcd display driver
        RLF     SHIFT3,f        ;generating the necessary
        RLF     SHIFT2,f        ;clock and data bits
        RLF     SHIFT1,f        ;
;Now output data/clock to portb,4,5...
        BTFSS   carry           ;is it a one?
        GOTO    ASMBL3          ;No? Goto zero bit subroutine
        BSF     DATA            ;Yes? Set data bit high portb,4
ASMBL2  BSF     CLOCK       	;Set clock high portb,5
        NOP                     ;data clocks on +ve edge
        BCF     CLOCK           ;set clock low
        GOTO    ASMBL4          ;skip ASMBL3, no data bit
ASMBL3  BCF     DATA        	;Set up a data 0
        BSF     CLOCK           ;Set clock high portb,5
        NOP                     ;data clocks on +ve edge
        BCF     CLOCK           ;setclock low   
ASMBL4  DECFSZ  BITS,f          ;BIT-1=0?
        GOTO    ASMBL1           ;Loop until all 43
;43 BIT string is now assembled so load into display selector...
        BSF     LOAD            ;Latch data in LCD driver
        NOP                     ;Nice long pulse
        BCF     LOAD            ;End of load pulse and sequence.
        RETURN
;
;The display DISPLAY_DELAY routine slows the shifting digits on the LCD.
;The DISPLAY_DELAY section of this program acts as a general purpose timer.
;DISPLAY_DELAY=1.6[DS_DEL](base10)cubed+20[DS_DEL]uS
;Min(01H)=23uS/Max(0FFH)=68secs
;Typ...10H=20mS 20H=130mS 30H=450mS 40H=1sec
;
DISPLAY_DELAY               	;
	MOVLW   035H            ;Set value for scroll speed in <scrl_1-1.h>
	MOVWF	DS_DEL		;hold in DS_DEL
DELAY	MOVF    DS_DEL,w        ;w=display delay
	BTFSC	TST_DLY		;Test for FLAG1,4 (short test delay)
	MOVLW	01H		;short delay value
	MOVWF	PTR1		;Store delay value
      	MOVWF   ITER1           ;Load this value
       	MOVWF   ITER2           ;into ITER2
      	MOVWF   ITER3           ;and ITER3
LOOP_DD	DECF    ITER1,f    	;Inner Loop TEMP1
       	BTFSS   zero            ;Is ITER1 zero?
      	GOTO    LOOP_DD         ;No? Loop again
      	MOVWF   ITER1           ;reload
       	DECF    ITER2,f         ;ITER2-1
       	BTFSS   zero            ;Is ITER2 zero?
      	GOTO    LOOP_DD         ;No? loop again
      	MOVF    PTR1,w        	;Restore DISPLAY_DELAY value
      	MOVWF   ITER2           ;reload
      	DECF    ITER3,f         ;ITER3-1
      	BTFSS   zero            ;Is ITER3 zero?
     	GOTO    LOOP_DD         ;Loop again
        RETURN                  ;end of DISPLAY_DELAY

;************************************************************************

DISP_NORM2
	BCF	rb1			;bank0
	BCF	B_SEGS			;CLEAR LUT_B FLAG
	BCF	pclath,0		;First eighth
	BCF	pclath,1		;of page
	BCF	pclath,2
	MOVLW	030H			;W=30H
	MOVWF	DIGADR			;DIGADR=30H
	CALL	ASC_SEGS		;CALL ASC_SEGS
	CLRF	SHIFTX			;LOAD COM1
	CALL	ASSEMBLE		;ASSEMBLE

	BSF	B_SEGS			;SET LUT_B FLAG
	CALL	ASC_SEGS		;CALL ASC_SEGS
	MOVLW	020H			;LOAD
	MOVWF	SHIFTX			;COM2
	CALL	ASSEMBLE		;ASSEMBLE
	CALL	DISPLAY_DELAY		;HOLD DISPLAY
	RETURN

;************************************************************************
; Set Message1... (note: this is not part of the standard MDM-1 firmware)

SET_MESSAGE1
	NOP
	MOVLW	'H'			; Set 1st character
	MOVWF	DISP5			;
	MOVLW	'I'			; Set 2nd character
	MOVWF	DISP4			;
	MOVLW	' '			; Set 3rd character
	MOVWF	DISP3			;
	MOVLW	' '			; Set 4th character
	MOVWF	DISP2			;
	MOVLW	' '			; Set 5th character
	MOVWF	DISP1			;
	RETURN				; Return from subroutine

;************************************************************************
; Set Message2... (note: this is not part of the standard MDM-1 firmware)

SET_MESSAGE2
	NOP
	MOVLW	'T'			; Set 1st character
	MOVWF	DISP5			;
	MOVLW	'H'			; Set 2nd character
	MOVWF	DISP4			;
	MOVLW	'E'			; Set 3rd character
	MOVWF	DISP3			;
	MOVLW	'R'			; Set 4th character
	MOVWF	DISP2			;
	MOVLW	'E'			; Set 5th character
	MOVWF	DISP1			;
	RETURN				; Return from subroutine

;************************************************************************
; Main program shell...  (note: this is not part of the standard MDM-1 firmware)

INIT	NOP
	CALL	SET_MESSAGE1		; Sets a standard 5 digit message
	NOP
	CALL	DISP_NORM2		; Perform display data preperation and display
	NOP
	CALL	SET_MESSAGE2		; Sets a standard 5 digit message
	NOP
	CALL	DISP_NORM2		; Perform display data preperation and display
	NOP
	GOTO	INIT			; Repeat complete program infinitely

	END
;************************************************************************
